part of ui_ex;

extension SwiperEx on Widget Function(BuildContext, int)? {
  Swiper swiper({
    required int itemCount,
    PageIndicatorLayout indicatorLayout = PageIndicatorLayout.NONE,
    PageTransformer? transformer,
    bool autoplay = false,
    SwiperLayout layout = SwiperLayout.DEFAULT,
    int autoplayDelay = kDefaultAutoplayDelayMs,
    bool autoplayDisableOnInteraction = true,
    int duration = kDefaultAutoplayTransactionDuration,
    void Function(int)? onIndexChanged,
    int? index,
    dynamic Function(int)? onTap,
    SwiperPlugin? control,
    bool loop = true,
    Curve curve = Curves.ease,
    Axis scrollDirection = Axis.horizontal,
    SwiperPlugin? pagination,
    List<SwiperPlugin>? plugins,
    ScrollPhysics? physics,
    Key? key,
    SwiperController? controller,
    CustomLayoutOption? customLayoutOption,
    double? containerHeight,
    double? containerWidth,
    double viewportFraction = 1.0,
    double? itemHeight,
    double? itemWidth,
    bool outer = false,
    double? scale,
    double? fade,
  }) =>
      Swiper(
        itemBuilder: this,
        indicatorLayout: indicatorLayout,
        transformer: transformer,
        itemCount: itemCount,
        autoplay: autoplay,
        layout: layout,
        autoplayDelay: autoplayDelay,
        autoplayDisableOnInteraction: autoplayDisableOnInteraction,
        duration: duration,
        onIndexChanged: onIndexChanged,
        index: index,
        onTap: onTap,
        control: control,
        loop: loop,
        curve: curve,
        scrollDirection: scrollDirection,
        pagination: pagination,
        plugins: plugins,
        physics: physics,
        key: key,
        controller: controller,
        customLayoutOption: customLayoutOption,
        containerHeight: containerHeight,
        containerWidth: containerWidth,
        viewportFraction: viewportFraction,
        itemHeight: itemHeight,
        itemWidth: itemWidth,
        outer: outer,
        scale: scale,
        fade: fade,
      );
}

extension SwiperListEx on List<Widget>? {
  Swiper swiper({
    bool autoplay = false,
    PageTransformer? transformer,
    int autoplayDelay = kDefaultAutoplayDelayMs,
    bool reverse = false,
    bool autoplayDisableOnInteraction = true,
    int duration = kDefaultAutoplayTransactionDuration,
    void Function(int)? onIndexChanged,
    int? index,
    dynamic Function(int)? onTap,
    bool loop = true,
    Curve curve = Curves.ease,
    Axis scrollDirection = Axis.horizontal,
    SwiperPlugin? pagination,
    SwiperPlugin? control,
    List<SwiperPlugin>? plugins,
    SwiperController? controller,
    Key? key,
    CustomLayoutOption? customLayoutOption,
    ScrollPhysics? physics,
    double? containerHeight,
    double? containerWidth,
    double viewportFraction = 1.0,
    double? itemHeight,
    double? itemWidth,
    bool outer = false,
    double scale = 1.0,
  }) =>
      Swiper.children(
        children: this ?? [],
        transformer: transformer,
        autoplay: autoplay,
        autoplayDelay: autoplayDelay,
        autoplayDisableOnInteraction: autoplayDisableOnInteraction,
        duration: duration,
        onIndexChanged: onIndexChanged,
        index: index,
        onTap: onTap,
        control: control,
        loop: loop,
        curve: curve,
        scrollDirection: scrollDirection,
        pagination: pagination,
        plugins: plugins,
        physics: physics,
        key: key,
        controller: controller,
        customLayoutOption: customLayoutOption,
        containerHeight: containerHeight,
        containerWidth: containerWidth,
        viewportFraction: viewportFraction,
        itemHeight: itemHeight,
        itemWidth: itemWidth,
        outer: outer,
        scale: scale,
      );
}
